﻿Public Class Form1
    ' Declare an account. Use WithEvents so we can eaily catch its events.
    Private WithEvents MyAccount As BankAccount

    ' Initialize the account.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Iniailize the account.
        MyAccount = New BankAccount(100)

        ' Display the current balance.
        txtBalance.Text = MyAccount.Balance.ToString("C")
    End Sub

    ' Add money to the account.
    Private Sub btnCredit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCredit.Click
        ' Add the money.
        Dim amount As Decimal = Decimal.Parse(txtAmount.Text)
        MyAccount.Credit(amount)

        ' Display the current balance.
        txtBalance.Text = MyAccount.Balance.ToString("C")
    End Sub

    ' Remove money from the account.
    Private Sub btnDebit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDebit.Click
        ' Remove the money.
        Dim amount As Decimal = Decimal.Parse(txtAmount.Text)
        MyAccount.Debit(amount)

        ' Display the current balance.
        txtBalance.Text = MyAccount.Balance.ToString("C")
    End Sub

    ' We're overdrawn.
    Private Sub MyAccount_Overdrawn(ByVal sender As Object, ByVal e As BankAccount.OverdrawnEventArgs) Handles MyAccount.Overdrawn
        MessageBox.Show("Insufficient funds.")
    End Sub
End Class
